#include "StdAfx.h"
#include "SliderScripletPlugin.h"

#include "NSlider.h"
#include "ScriptletConstant.h"
#include "ScriptletUtil.h"
#include "SliderDefUI.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_SLIDER_NODE, CSliderScriptletPlugin);
CSliderScriptletPlugin::CSliderScriptletPlugin(void)
{
}

CSliderScriptletPlugin::~CSliderScriptletPlugin(void)
{
}
BOOL CSliderScriptletPlugin::ModifyComponent(CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pTarget, pNode);
	if (bSuccess)
	{
		CNSlider* pSlider = reinterpret_cast<CNSlider*>(pTarget);
		if (pSlider == NULL)
		{
			return bSuccess;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;

		if (ScriptletUtil::GetAttrValue(pNode, SCRIPTLET_DIR_NODE, lValue) ||
			ScriptletUtil::GetValueAsAttr(pNode, SCRIPTLET_DIR_NODE, lValue))
		{
		}

		//TiXmlElement* pDirNode = pNode->FirstChildElement(SCRIPTLET_DIR_NODE);
		//if (pDirNode)
		//{
		//	if (ScriptletUtil::GetAttrValue(pImageNode, SCRIPTLET_SOURCE_NODE, szValue, SCRIPTLET_MAX_VALUE) ||
		//		ScriptletUtil::GetValueAsAttr(pImageNode, SCRIPTLET_SOURCE_NODE, szValue, SCRIPTLET_MAX_VALUE))
		//	{
		//		IImage* pImage = LoadImage(szValue);
		//		if (pImage)
		//		{
		//			int nPart = 1;
		//			if (ScriptletUtil::GetAttrValue(pImageNode, SCRIPTLET_PART_NODE, lValue) ||
		//				ScriptletUtil::GetValueAsAttr(pImageNode, SCRIPTLET_PART_NODE, lValue))
		//			{
		//				nPart = lValue;
		//			}
		//			if (pButton->SetBitmaps(pImage, nPart))
		//			{
		//				CRect rcBound;
		//				pTarget->GetBounds(&rcBound);
		//				if (rcBound.Width() == 0)
		//				{
		//					rcBound.right = rcBound.left + pImage->GetWidth()/max(1, nPart);
		//				}
		//				if (rcBound.Height() == 0)
		//				{
		//					rcBound.bottom = rcBound.top + pImage->GetHeight();
		//				}
		//				pTarget->MoveWindow(&rcBound);
		//			}
		//		}				
		//	}
		//}

		//if (ScriptletUtil::GetAttrValue(pNode, SCRIPTLET_TEXT_NODE, szValue, SCRIPTLET_MAX_VALUE) ||
		//	ScriptletUtil::GetValueAsAttr(pNode, SCRIPTLET_TEXT_NODE, szValue, SCRIPTLET_MAX_VALUE))
		//{
		//	pSlider->SetText(szValue);
		//}
		//if (ScriptletUtil::GetAttrValue(pNode, SCRIPTLET_PUSHED_NODE, szValue, SCRIPTLET_MAX_VALUE) ||
		//	ScriptletUtil::GetValueAsAttr(pNode, SCRIPTLET_PUSHED_NODE, szValue, SCRIPTLET_MAX_VALUE))
		//{
		//	BOOL bPushed = _tcsicmp(szValue, SCRIPTLET_TRUE_VALUE) == 0;
		//	pSlider->SetPushed(bPushed);
		//}
		//TiXmlElement* pImageNode = pNode->FirstChildElement(SCRIPTLET_IMAGE_NODE);
		//if (pImageNode)
		//{
		//	if (ScriptletUtil::GetAttrValue(pImageNode, SCRIPTLET_SOURCE_NODE, szValue, SCRIPTLET_MAX_VALUE) ||
		//		ScriptletUtil::GetValueAsAttr(pImageNode, SCRIPTLET_SOURCE_NODE, szValue, SCRIPTLET_MAX_VALUE))
		//	{
		//		IImage* pImage = LoadImage(szValue);
		//		if (pImage)
		//		{
		//			int nPart = 1;
		//			if (ScriptletUtil::GetAttrValue(pImageNode, SCRIPTLET_PART_NODE, lValue) ||
		//				ScriptletUtil::GetValueAsAttr(pImageNode, SCRIPTLET_PART_NODE, lValue))
		//			{
		//				nPart = lValue;
		//			}
		//			if (pSlider->SetBitmaps(pImage, nPart))
		//			{
		//				CRect rcBound;
		//				pTarget->GetBounds(&rcBound);
		//				if (rcBound.Width() == 0)
		//				{
		//					rcBound.right = rcBound.left + pImage->GetWidth()/max(1, nPart);
		//				}
		//				if (rcBound.Height() == 0)
		//				{
		//					rcBound.bottom = rcBound.top + pImage->GetHeight();
		//				}
		//				pTarget->MoveWindow(&rcBound);
		//			}
		//		}				
		//	}
		//}		
	}
	return bSuccess;
}
CComponent* CSliderScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CNSlider;
	return pComponent;
}